//
//  NRGridViewController.h
//
//  Created by Louka Desroziers on 05/01/12.

/***********************************************************************************
 *
 * Copyright (c) 2012 Louka Desroziers
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 ***********************************************************************************
 *
 * Referencing this project in your AboutBox is appreciated.
 * Please tell me if you use this class so we can cross-reference our projects.
 *
 ***********************************************************************************/

#import <UIKit/UIKit.h>
#import "NRGridView.h"

@interface NRGridViewController : UIViewController <NRGridViewDelegate, NRGridViewDataSource>
- (id)initWithGridLayoutStyle:(NRGridViewLayoutStyle)layoutStyle;
@property (nonatomic, readonly) NRGridViewLayoutStyle gridLayoutStyle;
@property (nonatomic, retain) NRGridView *gridView;

/** A Boolean value indicating if the controller clears the selection when the grid appears.
 * @discussion The default value of this property is YES. When YES, the grid view controller clears the grid current selection when it receives a viewWillAppear: message. Setting this property to NO preserves the selection. */
@property (nonatomic, assign) BOOL clearsSelectionOnViewWillAppear;
@end
